# Purpose: stat testing macro
# Input: argus_recoded_wtd
# Output: stattest.dt
#         stattest.dt.RData

# rm(list = ls(all = TRUE))
# options(run.main=TRUE)

################################################################################
########################## Auxiliary Functions #################################
################################################################################
{
  
  # Function to validate "comparison" dataset against "model" dataset.
  validate_41 <- function(params,filename_list,key_column_list) {
    
    path <- params$path
    dump_diff_file <- params$dump_diff_file
    
    if (!file.exists(paste0(path,'/Validation'))) { 
      dir.create(paste0(path,'/Validation')) 
    }
    
    for (j in 1:length(filename_list)) {
      #j<-1
      ModelFileName <- filename_list[[j]][1]
      dot_pos <- tail(gregexpr('.',ModelFileName,fixed=TRUE)[[1]],n=1)
      ModelFileType <- substr(ModelFileName,dot_pos+1,nchar(ModelFileName))
      
      if (file.exists(ModelFileName)) {
        
        key_column <- key_column_list[[j]]
        
        # Find the matching file in the comparison folder
        ComparisonFileName <- filename_list[[j]][2]
        dot_pos <- tail(gregexpr('.',ComparisonFileName,fixed=TRUE)[[1]],n=1)
        ComparisonFileType <- substr(ComparisonFileName,dot_pos+1,
                                     nchar(ComparisonFileName))
        
        message(paste0('\n  Validating ',ComparisonFileName))
        message(paste0('  against ',ModelFileName))
        
        # Output folder and file names
        outfolder <- paste0(path,'/Validation')
        filename <- substr(ComparisonFileName,1,dot_pos-1)
        char_pos <- tail(gregexpr('/',filename,fixed=TRUE)[[1]],n=1)
        filename <- substr(filename,char_pos+1,nchar(filename))
        filename <- paste0('/diff_',filename)
        outname <- base::paste0(outfolder,filename)
        
        # Upload files
        if (ModelFileType == 'sas7bdat') {
          Modelfile <- haven::read_sas(ModelFileName)
        } else if (ModelFileType == 'csv') {
          Modelfile <- read.csv(file=ModelFileName,stringsAsFactors = F)
        } else if (ModelFileType == 'RData') {
          Modelfile <- loadRData_noalloc(ModelFileName)
        } else if (ModelFileType == 'xlsx') {
          print('  - Please, add capability to read xlsx files.')
        }
        if (!('data.table' %in% class(Modelfile))) {
          Modelfile <- as.data.table(Modelfile)
        }
        colnames(Modelfile) <- base::tolower(base::colnames(Modelfile))
        
        if (nrow(Modelfile) == 0) {
          
          if (ComparisonFileType == 'sas7bdat') {
            Comparisonfile <- haven::read_sas(ComparisonFileName)
          } else if (ComparisonFileType == 'csv') {
            Comparisonfile <- read.csv(file=ComparisonFileName,stringsAsFactors = F)
          } else if (ComparisonFileType == 'RData') {
            Comparisonfile <- loadRData_noalloc(ComparisonFileName)
          } else if (ComparisonFileType == 'xlsx') {
            print('  - Please, add capability to read xlsx files.')
          }
          colnames(Comparisonfile) <- base::tolower(base::colnames(Comparisonfile))
          
          if (nrow(Comparisonfile) == 0) {
            
            message('  - No discrepancies were found.')
            
          } else {
            
            message('  - Discrepancies were found.')
            message(paste0('    Dimensions of model dataset were ',
                           toString(nrow(Modelfile)),' x ',
                           toString(ncol(Modelfile))))
            message(paste0('    while dimensions of comparison dataset were ',
                           toString(nrow(Comparisonfile)),' x ',
                           toString(ncol(Comparisonfile))))
            
          }
          
        } else {
          
          if (ComparisonFileType == 'sas7bdat') {
            Comparisonfile <- haven::read_sas(ComparisonFileName)
          } else if (ComparisonFileType == 'csv') {
            Comparisonfile <- read.csv(file=ComparisonFileName,stringsAsFactors = F)
          } else if (ComparisonFileType == 'RData') {
            Comparisonfile <- loadRData_noalloc(ComparisonFileName)
          } else if (ComparisonFileType == 'xlsx') {
            print('  - Please, add capability to read xlsx files.')
          }
          if (!('data.table' %in% class(Comparisonfile))) {
            Comparisonfile <- as.data.table(Comparisonfile)
          }
          colnames(Comparisonfile) <- base::tolower(base::colnames(Comparisonfile))
          
          if (nrow(Comparisonfile) == 0) {
            
            message('  - Discrepancies were found.')
            message(paste0('    Dimensions of model dataset were ',
                           toString(nrow(Modelfile)),' x ',
                           toString(ncol(Modelfile))))
            message(paste0('    while dimensions of comparison dataset were ',
                           toString(nrow(Comparisonfile)),' x ',
                           toString(ncol(Comparisonfile))))
            
          } else {
            
            if (params$path == 'E:/Citi_Amazon') {
              Modelfile[,stddev := NULL]
              Modelfile[,stat := ifelse(stat == 'ExposureFreq1 - Unexposed','Low Exposure - Unexposed',
                                 ifelse(stat == 'ExposureFreq2 - Unexposed','Medium Exposure - Unexposed',
                                 ifelse(stat == 'ExposureFreq3 - Unexposed','High Exposure - Unexposed',
                                 ifelse(stat == 'ExposureFreq2 - ExposureFreq1','Medium Exposure - Low Exposure',
                                 ifelse(stat == 'ExposureFreq3 - ExposureFreq1','High Exposure - Low Exposure',
                                 ifelse(stat == 'ExposureFreq3 - ExposureFreq2','High Exposure - Medium Exposure',
                                        stat))))))]
            }
            
            overlap_cols <- merge(Modelfile[,key_column,with=F],
                                  Comparisonfile[,key_column,with=F],by=key_column)
            Comparisonfile <- merge(Comparisonfile,overlap_cols,by=key_column)
            Modelfile <- merge(Modelfile,overlap_cols,by=key_column)
            
            # Replace NA with 0 in Modelfile to match Comparisonfile
            for (i in seq_len(ncol(Modelfile))) { 
              set(Modelfile, which(is.na(Modelfile[[i]])), i, 0) 
            }
            
            # Replace NA with 0 in Comparisonfile to match Modelfile
            for (i in seq_len(ncol(Comparisonfile))) { 
              set(Comparisonfile, which(is.na(Comparisonfile[[i]])), i, 0) 
            }
            
            # Compare files
            validate_dt_file(Modelfile,Comparisonfile,key_column,outname,
                             dump_diff_file)
            
          }
          
        }
        
        rm(Modelfile)
        rm(Comparisonfile)
        foo <- gc()
        
      } else {
        
        message(paste0('  - ',ModelFileName,' does not exist.'))
        
      }
      
    }
    
  }
  
  # dataset = demo_sel
  # var = var.ttest
  # wt = weightvar
  # group = freqlvl
  # type = segd
  wtd.t.test.se <- function (dataset,var,wt,group,type,demovar,alternative) {
    
    #############################################################################
    # 1. checks
    #############################################################################
    if (is.null(dataset)) {stop("Please specify dataset")}
    if (is.null(var)) {stop("Please specify var")}
    if (is.null(wt)) {stop("Please specify weight")}
    if (is.null(group)) {stop("Please specify group")}
    if (length(unique(dataset[[group]])) != 2) {
      stop("group variable must have exactly 2 levels")}
    
    
    ############################################################################
    # 2. weighted sample size, mean, and variance
    ############################################################################
    
    # unwtd.n <- length(dataset[dataset[[group]] == 0,get(var)])
    # unwtd.n2 <- length(dataset[dataset[[group]] == 1,get(var)])
    # 
    # n <- sum(dataset[dataset[[group]] == 0,get(wt)])
    # n2 <- sum(dataset[dataset[[group]] == 1,get(wt)])
    # 
    # dataset[,`:=`(weighted_var = dataset[[wt]]*dataset[[var]])]
    # mx <- sum(dataset[dataset[[group]] == 0,weighted_var])/n
    # my <- sum(dataset[dataset[[group]] == 1,weighted_var])/n2
    # 
    # Np <- length(dataset[(dataset[[group]] == 0) & 
    #                      (dataset[[wt]]    != 0),get(var)])
    # vx <- sum(dataset[dataset[[group]] == 0,get(wt)]*
    #           ((dataset[dataset[[group]] == 0,get(var)]-mx)^2))*Np/(Np-1)/n
    # 
    # Np <- length(dataset[(dataset[[group]] == 1) & 
    #                      (dataset[[wt]]    != 0),get(var)])
    # vy <- sum(dataset[dataset[[group]] == 1,get(wt)]*
    #           ((dataset[dataset[[group]] == 1,get(var)]-my)^2))*Np/(Np-1)/n2
    
    # dataset[dataset[[group]] == 0,get(wt)]
    wtd.stats <- dataset[, {
        unwtd.n = length(get(var))
        wtd.n = sum(get(wt))
        m = Hmisc::wtd.mean(get(var), get(wt), na.rm = TRUE)
        v = Hmisc::wtd.var(get(var), get(wt), na.rm = TRUE)
        list(unwtd.n = unwtd.n,
               wtd.n = wtd.n,
                  m = m,
                  v = v)
      }, by = get(group)]
    wtd.stats <- wtd.stats[order(get)]
    
    unwtd.n <- wtd.stats[["unwtd.n"]][[1]]
    unwtd.n2 <- wtd.stats[["unwtd.n"]][[2]]
    
    n <- wtd.stats[["wtd.n"]][1]
    n2 <- wtd.stats[["wtd.n"]][2]
    
    mx <- wtd.stats[["m"]][1]
    my <- wtd.stats[["m"]][2]
    
    vx <- wtd.stats[["v"]][1]
    # (using unwtd.n to match SAS output)
    if (wtd.stats$get[1] == 0) {
      Np <- length(dataset[(dataset[[group]] == 0) &
                             (dataset[[wt]]    != 0),get(var)])
      vx <- sum(dataset[dataset[[group]] == 0,get(wt)]*
                  ((dataset[dataset[[group]] == 0,get(var)]-mx)^2))*Np/(Np-1)/unwtd.n
    }
    vy <- wtd.stats[["v"]][2]
    
    #############################################################################
    # 3. F-test
    #############################################################################
    if ((unwtd.n < 2) | (unwtd.n2 < 2)) {
      
      # Print out warning message but do not stop the ttest process
      if (unwtd.n < 2) message(paste("          Warning: not enough 'x' sample (P-value = Null)."))
      
      if (unwtd.n2 < 2) message(paste("          Warning: not enough 'y' sample (P-value = Null)."))
      
      coef <- c(NA, NA, NA)
      out2 <- c(NA, NA, NA, NA, NA, NA,NA,NA,NA)
      
      names(coef) <- c("t.value", "df", "p.value")
      names(out2) <- c("Difference", "Mean.x", "Mean.y", "Std. Err"
                       , "F.value", "F-test p.value","numdf","dendf","variances")
      
      out <- list("Not enough sample to do T-Test", coef, 
                  out2)
      names(out) <- c("test", "coefficients", "additional")
      
    } else if (vx == 0 && vy == 0) {
      
      # Print out warning message but do not stop the ttest process
      message(paste("          Warning: 'x' and 'y' are both constant (P-value = Null)."))
      
      coef <- c(NA, NA, NA)
      out2 <- c(NA, NA, NA, NA, NA, NA,NA,NA,NA)
      
      names(coef) <- c("t.value", "df", "p.value")
      names(out2) <- c("Difference", "Mean.x", "Mean.y", "Std. Err"
                       , "F.value", "F-test p.value","numdf","dendf","variances")
      
      out <- list("Data is essentially constant", coef, out2)
      
      names(out) <- c("test", "coefficients", "additional")
      
    } else {
      
      foldedf <- max(vx, vy) / min(vx, vy)  
      
      if (vx > vy) {
        
        dfnum <- unwtd.n-1 #n - 1 (using unwtd.n to match SAS output)
        dfden <- unwtd.n2-1 #n2 - 1 (using unwtd.n2 to match SAS output)
        
      } else {
        
        dfnum <- unwtd.n2-1 #n2 - 1 (using unwtd.n2 to match SAS output)
        dfden <- unwtd.n-1 #n - 1 (using unwtd.n to match SAS output)
        
      }
      
      pf.F <- 2 * pf(foldedf, df1 = dfnum, df2 = dfden, lower.tail = F)
      
      #############################################################################
      # 4. t-test
      #############################################################################
      
      dif <- mx - my
      sxy <- sqrt((vx/n) + (vy/n2))
      
      if (pf.F <= 0.05) {
        
        # df <- (((vx/n) + (vy/n2))^2)/((((vx/n)^2)/(n - 1)) + 
        #                                 ((vy/n2)^2/(n2 - 1)))
        # we think SAS does it this way
        df <- (((vx/unwtd.n) + (vy/unwtd.n2))^2)/((((vx/unwtd.n)^2)/(unwtd.n - 1)) +
                                  ((vy/unwtd.n2)^2/(unwtd.n2 - 1)))
        
        t <- (mx - my)/sxy
        if (alternative == "two.tailed") {
          p.value <- (1-pt(abs(t),df))*2
        } else if (alternative == "greater") {
          p.value <- pt(t,df,lower.tail=F)
        } else if (alternative == "less") {
          p.value <- pt(t,df,lower.tail=T)
        }
        
        coef <- c(t, df, p.value)
        out2 <- c(dif, mx, my, sxy, foldedf, pf.F,dfnum,dfden,"Unequal")
        names(coef) <- c("t.value","df","p.value")
        names(out2) <- c("Difference","Mean.x","Mean.y","Std. Err","F.value",
                         "F-test p.value","numdf","dendf","variances")
        out <- list("Two Sample Weighted T-Test (Welch) (unequal variances)", 
                    coef, out2)
        names(out) <- c("test", "coefficients", "additional")
        
      } else {
        
        #df <- n + n2 - 2
        df <- unwtd.n + unwtd.n2 - 2 # (to match SAS code)
      
        t <- (mx - my)/sxy
        if (alternative == "two.tailed") {
          p.value <- (1-pt(abs(t),df))*2
        } else if (alternative == "greater") {
          p.value <- pt(t,df,lower.tail=F)
        } else if (alternative == "less") {
          p.value <- pt(t,df,lower.tail=T)
        }
        
        coef <- c(t, df, p.value)
        out2 <- c(dif, mx, my, sxy, foldedf, pf.F,dfnum,dfden,"Equal")
        names(coef) <- c("t.value", "df", "p.value")
        names(out2) <- c("Difference","Mean.x","Mean.y","Std. Err","F.value",
                         "F-test p.value","numdf","dendf","variances")
        out <- list("Two Sample Weighted T-Test (equal variances)", coef, out2)
        names(out) <- c("test", "coefficients", "additional")
        
      }
      
    }
    
    return(out)
  }
  
  
  # iexp = x
  # publisher = publishername
  # creative = creativename
  # tactic = tacticname
  # mediatype = mediatypename
  # market = marketname
  ttests <- function(params,datain,output.dt,iexp,freqlvl,exposure,statexpdesc,
                     weightvar,antime,anframe,freq1,freq2,prfr,alternative,
                     publisher,creative,tactic,mediatype,market,pretime) {
    
    freq <- substr(statexpdesc,1,regexpr('-',statexpdesc)[1]-2)
    Ngroups <- length(unique(datain[[freqlvl]]))
    
    if (class(params$demolst) == "matrix") {
      demolst <- lapply(1:(nrow(params$demolst)), 
                        function (i) params$demolst[i ,])
    } else {
      demolst <- params$demolst
    }
    
    if (class(params$demodesclst) == "matrix") {
      demodesclst <- lapply(1:(nrow(params$demodesclst)), 
                            function (i) params$demodesclst[i ,])
    } else {
      demodesclst <- params$demodesclst
    }
    
    if (class(params$agedesc) == "matrix") {
      agedesc <- lapply(1:(nrow(params$agedesc)), 
                        function (i) params$agedesc[i ,])
    } else {
      agedesc <- params$agedesc
    }
    
    if (class(params$genderdesc) == "matrix") {
      genderdesc <- lapply(1:(nrow(params$genderdesc)), 
                           function (i) params$genderdesc[i ,])
    } else {
      genderdesc <- params$genderdesc
    }
    
    # Loop through demos
    for (dems in 1:length(demolst[[iexp]])) {
      # dems = 1
      demovar  <- tolower(demolst[[iexp]][dems])
      demoname <- demodesclst[[iexp]][dems]
      agename <- agedesc[[iexp]][dems]
      gendername <- genderdesc[[iexp]][dems]
      message(paste0('      > Demo: ',demoname, ' {'))
      filter.demo <- paste0('(datain$',demovar, " == 1)")
      message(paste0('        filter: ',gsub('datain$','',filter.demo,fixed=T)))
      if (Ngroups == 2) { 
        
        keepvar <- c('respondentid',freqlvl,weightvar,'sample',
                     grep(paste0(antime,"diff"),names(datain),value=T))
        for (segs in 1:length(params$segmentlst)) {
          # segs = 1
          seg1 <- tolower(params$segmentlst[segs])
          keepvar <- c(keepvar,grep(paste0(seg1,"_carduser_"),
                                    names(datain),value=T))
          keepvar <- c(keepvar,grep(paste0(seg1,"_cardholder_"),
                                    names(datain),value=T))
        }
        
        demo_sel <- datain[eval(parse(text=filter.demo)),keepvar,with=F] 
        Ngroups <- length(unique(demo_sel[[freqlvl]]))
      }
      
      # Loop through spend segments
      for (segs in 1:length(params$segmentlst)) {
        # segs = 1
        segm <- tolower(params$segmentlst[segs])
        segd <- params$segmentdesclst[segs]
        seg1 <- segm
        segkey <- params$segmentdeslstkey[segs]
        totvar <- params$totalvarlst[segs]
        message(paste0('        + Merchant: ',segd,' {'))
        
        ################## Part 1 of 3: All ####################################
        
        # For slice over freqlvl and demo
        # varname.dict <- list('carduser' = 'Card User',
        #                       'cardholder' = 'Card Owner',
        #                       'balyes' = 'Balance Active',
        #                       'openflag' = 'Card Opening',
        #                       'closeflag' = 'Card Closing'
        # )
        # var.ttests <- paste0(segm,"_",names(varname.dict),"_",antime,
        #                        ifelse(params$stattest.testperiod == 0,"diff",""))
        
        var.ttests <- paste0(segm,"_",tolower(params$statsforttest$all),"_",antime,
                             ifelse(params$stattest.testperiod == 0,"diff",""))
                        
        for (ivar in seq_along(var.ttests)) {
          #ivar = 1
          var.ttest <- var.ttests[ivar]
          message(paste0('          ~ Variable_Name: ',
                         params$statsdescforttest$all[ivar],
                         ' (var.ttest: ',var.ttest,')'))
          if (Ngroups == 2) {
            result <- wtd.t.test.se(dataset = demo_sel
                                   ,var = var.ttest
                                   ,wt = weightvar
                                   ,group = freqlvl
                                   ,type = segd
                                   ,demovar = demovar
                                   ,alternative = alternative
                                   )
            
            # Modelfile2[((exposure == 'Citi Amazon - Any Digital Exposure (4/17/17 - 7/31/17)') &
            #            (demo == demoname) & (stat == 'ExposureFreq2 - ExposureFreq1') & (merchant == segd) &
            #            (variable_name == params$statsdescforttest$all[ivar]) &
            #            (preperiod == prfr)),Probt1]
            # result$coefficients[['p.value']]/2
            
            result.dt <- data.table(
              variable   = var.ttest
              , Exposure   = exposure
              , PrePeriod  = prfr
              , TestPeriod = anframe
              , Type       = 'Exposure Frequency'
              , Demo       = demoname
              , freq1      = freq1
              , freq2      = freq2
              , Merchant   = segd
              , stat       = statexpdesc
              , wherestate = params$statsdescforttest$all[ivar]
              , method     = result[[1]]
              , numdf      = result[[3]][7]
              , dendf      = result[[3]][8]
              , fvalue     = result[[3]][5]
              , probf      = result[[3]][6]
              , variances  = result[[3]][9]
              , tvalue     = result[[2]][1]
              , df         = result[[2]][2]
              , pvalue     = result[[2]][3]
              , difference = result[[3]][1]
              , meanx      = result[[3]][2]
              , meany      = result[[3]][3]
              , stderr     = result[[3]][4]
              , publisher  = publisher
              , creative   = creative
              , tactic     = tactic
              , mediatype  = mediatype
              , market     = market
              , age        = agename
              , gender     = gendername
              , merchkey   = segkey
              , freq       = freq
            )
          } else {
            result.dt <- data.table(
              variable   = var.ttest
              , Exposure   = exposure
              , PrePeriod  = prfr
              , TestPeriod = anframe
              , Type       = 'Exposure Frequency'
              , Demo       = demoname
              , freq1      = freq1
              , freq2      = freq2
              , Merchant   = segd
              , stat       = statexpdesc
              , wherestate = params$statsdescforttest$all[ivar]
              , method     = NA
              , numdf      = NA
              , dendf      = NA
              , fvalue     = NA
              , probf      = NA
              , variances  = NA
              , tvalue     = NA
              , df         = NA
              , pvalue     = NA
              , difference = NA
              , meanx      = NA
              , meany      = NA
              , stderr     = NA
              , publisher  = publisher
              , creative   = creative
              , tactic     = tactic
              , mediatype  = mediatype
              , market     = market
              , age        = agename
              , gender     = gendername
              , merchkey   = segkey
              , freq       = freq
            )
          }
          output.dt <- data.table::rbindlist(list(output.dt, result.dt))
          
        }
        
        ################## Part 2 of 3: Card User ##############################
        
        if (Ngroups == 2) {
          # Subset input data for t-test
          wherestate = paste0('((demo_sel$',segm,'_carduser_',pretime,
                              ' > 0) | (demo_sel$',segm,'_carduser_test > 0))')
          message('          Carduser slice')
          message(paste0('          filter: ',gsub('demo_sel$','',wherestate,fixed=T)))
          
          keepvar <- c('respondentid',freqlvl,weightvar,'sample',
                       grep(paste0(antime,"diff"),names(demo_sel),value=T))
          datain.carduser = demo_sel[eval(parse(text=wherestate)),keepvar,with=F] 
          NBuyers <- nrow(datain.carduser)
          Ngroups.B <- length(unique(datain.carduser[[freqlvl]]))
          message(paste0('            Number of respondents in carduser slice: ',
                         NBuyers))
        } else {
          NBuyers <- 0
          Ngroups.B <- 0
          message(paste0('          Variable ',freqlvl,' has ',Ngroups,' values',
                         ' in this slice. T-tests are not being performed.'))
        }
        
        # Loop through stats with carduser slice
        var.ttests <- c(paste0(segm,"_",tolower(params$statsforttest$cardusers),"_",
                               antime,ifelse(params$stattest.testperiod == 0,"diff","")),
                       paste0(tolower(params$totalvarlst[segs]),'_spend_',antime,'diff'))
                       #paste0(tolower(params$totalvarlst[segs]),'_spd_',antime,'diff'))
        var.names <- c(params$statsdescforttest$cardusers,'Total Credit Card Spend')
        for (ivar in seq_along(var.ttests)) {
          #ivar = 7
          var.ttest <- var.ttests[ivar]
          message(paste0('          ~ Variable_Name: ',var.names[ivar],
                         ' (var.ttest: ',var.ttest,')'))
          
          if ((NBuyers > 0) & (Ngroups == 2) & (Ngroups.B == 2)) {
            result <- wtd.t.test.se(dataset = datain.carduser
                                    ,var = var.ttest
                                    ,wt = weightvar
                                    ,group = freqlvl
                                    ,type = segd
                                    ,demovar = demovar
                                    ,alternative = alternative
            )
            
            # Modelfile[((exposure == 'Capital One - Any Capital One Exposure - 10/01/16-11/30/16') &
            #            (demo == demoname) & (stat == statexpdesc) & (merchant == segd) &
            #            (variable_name == var.names[ivar]) &
            #            (preperiod == prfr)),Probt1]
            # result$coefficients[['p.value']]/2
            
            result.dt <- data.table(
              variable   = var.ttest
              , Exposure   = exposure
              , PrePeriod  = prfr
              , TestPeriod = anframe
              , Type       = 'Exposure Frequency'
              , Demo       = demoname
              , freq1      = freq1
              , freq2      = freq2
              , Merchant   = segd
              , stat       = statexpdesc
              , wherestate = var.names[ivar]
              , method     = result[[1]]
              , numdf      = result[[3]][7]
              , dendf      = result[[3]][8]
              , fvalue     = result[[3]][5]
              , probf      = result[[3]][6]
              , variances  = result[[3]][9]
              , tvalue     = result[[2]][1]
              , df         = result[[2]][2]
              , pvalue     = result[[2]][3]
              , difference = result[[3]][1]
              , meanx      = result[[3]][2]
              , meany      = result[[3]][3]
              , stderr     = result[[3]][4]
              , publisher  = publisher
              , creative   = creative
              , tactic     = tactic
              , mediatype  = mediatype
              , market     = market
              , age        = agename
              , gender     = gendername
              , merchkey   = segkey
              , freq       = freq
            )
          } else {
            result.dt <- data.table(
              variable   = var.ttest
              , Exposure   = exposure
              , PrePeriod  = prfr
              , TestPeriod = anframe
              , Type       = 'Exposure Frequency'
              , Demo       = demoname
              , freq1      = freq1
              , freq2      = freq2
              , Merchant   = segd
              , stat       = statexpdesc
              , wherestate = var.names[ivar]
              , method     = NA
              , numdf      = NA
              , dendf      = NA
              , fvalue     = NA
              , probf      = NA
              , variances  = NA
              , tvalue     = NA
              , df         = NA
              , pvalue     = NA
              , difference = NA
              , meanx      = NA
              , meany      = NA
              , stderr     = NA
              , publisher  = publisher
              , creative   = creative
              , tactic     = tactic
              , mediatype  = mediatype
              , market     = market
              , age        = agename
              , gender     = gendername
              , merchkey   = segkey
              , freq       = freq
            )
          }
          output.dt <- data.table::rbindlist(list(output.dt, result.dt))
          
        }
        
        if (exists('datain.carduser')) {
          rm(datain.carduser)
          foo <- gc()
        }
        
        ################## Part 3 of 3: Card Holder ############################
        
        if (Ngroups == 2) {
          # Subset input data for t-test
          wherestate = paste0('((demo_sel$',segm,'_cardholder_',pretime,
                              ' > 0) | (demo_sel$',segm,'_cardholder_test > 0))')
          message('          Cardholder slice')
          message(paste0('          filter: ',gsub('demo_sel$','',wherestate,fixed=T)))
          datain.cardholder = demo_sel[eval(parse(text=wherestate)),keepvar,with=F] 
          NBuyers <- nrow(datain.cardholder)
          Ngroups.B <- length(unique(datain.cardholder[[freqlvl]]))
          message(paste0('            Number of respondents in cardholder slice: ',
                         NBuyers))
        } else {
          NBuyers <- 0
          Ngroups.B <- 0
          message(paste0('          Variable ',freqlvl,' has ',Ngroups,' values',
                         ' in this slice. T-tests are not being performed.'))
        }
        
        # Loop through stats with cardholder slice
        var.ttests <- paste0(segm,"_",tolower(params$statsforttest$cardholder),"_",antime,
                            ifelse(params$stattest.testperiod == 0,"diff",""))
        for (ivar in seq_along(var.ttests)) {
          #ivar = 1
          var.ttest <- var.ttests[ivar]
          message(paste0('          ~ Variable_Name: ',
                         params$statsdescforttest$cardholder[ivar],
                         ' (var.ttest: ',var.ttest,')'))
          
          if ((NBuyers > 0) & (Ngroups == 2) & (Ngroups.B == 2)) {
            result <- wtd.t.test.se(dataset = datain.cardholder
                                    ,var = var.ttest
                                    ,wt = weightvar
                                    ,group = freqlvl
                                    ,type = segd
                                    ,demovar = demovar
                                    ,alternative = alternative
            )
            
            result.dt <- data.table(
              variable   = var.ttest
              , Exposure   = exposure
              , PrePeriod  = prfr
              , TestPeriod = anframe
              , Type       = 'Exposure Frequency'
              , Demo       = demoname
              , freq1      = freq1
              , freq2      = freq2
              , Merchant   = segd
              , stat       = statexpdesc
              , wherestate = params$statsdescforttest$cardholder[ivar]
              , method     = result[[1]]
              , numdf      = result[[3]][7]
              , dendf      = result[[3]][8]
              , fvalue     = result[[3]][5]
              , probf      = result[[3]][6]
              , variances  = result[[3]][9]
              , tvalue     = result[[2]][1]
              , df         = result[[2]][2]
              , pvalue     = result[[2]][3]
              , difference = result[[3]][1]
              , meanx      = result[[3]][2]
              , meany      = result[[3]][3]
              , stderr     = result[[3]][4]
              , publisher  = publisher
              , creative   = creative
              , tactic     = tactic
              , mediatype  = mediatype
              , market     = market
              , age        = agename
              , gender     = gendername
              , merchkey   = segkey
              , freq       = freq
            )
          } else {
            result.dt <- data.table(
              variable   = var.ttest
              , Exposure   = exposure
              , PrePeriod  = prfr
              , TestPeriod = anframe
              , Type       = 'Exposure Frequency'
              , Demo       = demoname
              , freq1      = freq1
              , freq2      = freq2
              , Merchant   = segd
              , stat       = statexpdesc
              , wherestate = params$statsdescforttest$cardholder[ivar]
              , method     = NA
              , numdf      = NA
              , dendf      = NA
              , fvalue     = NA
              , probf      = NA
              , variances  = NA
              , tvalue     = NA
              , df         = NA
              , pvalue     = NA
              , difference = NA
              , meanx      = NA
              , meany      = NA
              , stderr     = NA
              , publisher  = publisher
              , creative   = creative
              , tactic     = tactic
              , mediatype  = mediatype
              , market     = market
              , age        = agename
              , gender     = gendername
              , merchkey   = segkey
              , freq       = freq
            )
          }
          output.dt <- data.table::rbindlist(list(output.dt, result.dt))
        }
        
        if (exists('datain.cardholder')) {
          rm(datain.carduser)
          foo <- gc()
        }
        
        message(paste0('          }'))
        
      } # end of segment loop
      
      if (exists('demo_sel')) {
        rm(demo_sel)
        foo <- gc()
      }
      message(paste0('        }'))
      
    } # end of demo loop
    
    return(output.dt)
  }
  
  cleantest_Excel <- function(output.dt) {
    
    stattest.dt <- copy(output.dt)
    
    setnames(stattest.dt, old = 'wherestate',new = 'variable_name')
    setnames(stattest.dt, old = names(stattest.dt),new = tolower(names(stattest.dt)))
    setnames(stattest.dt, old = 'probt1',new = 'Probt1')
    
    keepers = c("variable_name","exposure","preperiod","testperiod","demo",
                "freq1","freq2","stat","merchant","Probt1")
    
    stattest.dt <- stattest.dt[, keepers, with=FALSE]
    
    return(stattest.dt)
    
  }
  
  cleantest_NMC <- function(output.dt) {
    
    stattest.dt <- copy(output.dt)
    
    # Rename columns
    setnames(stattest.dt, old = c('Exposure','Type','Merchant','Demo'), 
             new = c('exposure','type','merch','demo'))
    
    # Add columns
    stattest.dt <- stattest.dt[
      ,metric := ifelse(grepl("_spend_", variable), "Spend per Buyer",
                 ifelse(grepl("_trans_", variable), "Transactions per Buyer",
                 ifelse(grepl("_d_per_tr_", variable), "Spend per Transaction",
                 ifelse(grepl("_share_", variable), "Share of Category Spend",
                 ifelse(grepl("_transyes", variable), "Buyers", "")))))]
    stattest.dt[
      ,metric := ifelse(grepl("Spend Per Person", wherestate), "Spend per Person", 
                 ifelse(grepl("Trans Per Person", wherestate), "Total Transactions",
                 ifelse(grepl("Transyes Per Person", wherestate),"Buyers",metric)))]
    stattest.dt[ , predesc := params$prefr]
    stattest.dt[ , pretypedesc := params$prefrtype]
    stattest.dt[ , campaigndesc := params$testfr]
    stattest.dt[ , postdesc := params$postfr]
    stattest.dt[ , posttypedesc := params$postfrtype] 
    stattest.dt[ , testdesc := params$tspsfr]
    stattest.dt[ , PeriodType := "Lift"]
    
    # Delete rows that ...
    # if class = " " or class = "Diff (1-2)" then deleteflag = 0; else deleteflag = 1;
    # 
    # if deleteflag = 1 then delete;
    
    
    # Keep only columns to be written to disk
    keepers = c('variable','metric','exposure','publisher','creative',
                'tactic','mediatype','market','age','gender','predesc',
                'pretypedesc','campaigndesc','postdesc','posttypedesc','testdesc',
                'merch','merchkey','type','demo','freq1','freq2','freq','Probt1',
                'PeriodType')
    
    stattest.dt <- stattest.dt[, keepers, with=FALSE]
    
    return(stattest.dt)
    
  }
  
}
################################################################################
############################# Main Function ####################################
################################################################################
{
  
  main_41 <- function(params,argus_recoded_wtd) {
    
    message(paste0('\n  Memory usage is: ',memory.size(max=FALSE),' MB'))
    
    # possible values for alternative ("two.tailed","greater","less")
    alternative <- tolower(params$alternative)
    weightvar <- tolower(params$rimweightvar)
    
    statexpdesc.list <- c("Exposed - Unexposed","Low Exposure - Unexposed",
                          "Medium Exposure - Unexposed","High Exposure - Unexposed",
                          "Medium Exposure - Low Exposure","High Exposure - Low Exposure",
                          "High Exposure - Medium Exposure")
    freq1.list <- c(0,0,0,0,1,1,2)
    freq2.list <- c(1,1,2,3,2,3,3)
    
    if (class(params$demolst) == "matrix") {
      demolst <- lapply(1:(nrow(params$demolst)), 
                        function (i) params$demolst[i ,])
    } else {
      demolst <- params$demolst
    }
    
    # Loop over preperiod
    for (iprtime in params$mod_41$start_preper:length(params$pre_list)) {
      #iprtime = 1
      pretime <- params$pre_list[[iprtime]]$pretime
      antime <- params$pre_list[[iprtime]]$antime
      prfr <- params$pre_list[[iprtime]]$prfr
      anframe <- params$pre_list[[iprtime]]$anfr
      message(paste0('\n  Preperiod: ', pretime,' {'))
    
      # Loop over exposures
      for (x in params$mod_41$start_exp:params$exposuren) {
        #x = 1
        startexp <- Sys.time()
        publishername <- params$publisher[x]
        creativename <- params$creative[x]
        tacticname <- params$tactic[x]
        mediatypename <- params$mediatype[x]
        marketname <- params$market[x]
        exposure <- params$exposure[[x]]
        demonames <- tolower(demolst[[x]])
        message(paste0('  - Exposure: ',exposure,' {'))
        
        output.dt <- data.table(NULL)
        
        # Loop over frequencies
        freqlvl.list <- c(tolower(params$expyes[[x]]),rep(tolower(params$expfreq[[x]]),6))
        for (ifreq in 1:7) {
          # ifreq = 1
          statexpdesc <- statexpdesc.list[ifreq]
          freqlvl <- freqlvl.list[ifreq]
          freq1 <- freq1.list[ifreq]
          freq2 <- freq2.list[ifreq]
          message(paste0('    * Stat: ',statexpdesc, ' {'))
          filter.freq <- paste0('(argus_recoded_wtd$',freqlvl, " %in% c(",
                                freq1, ",",freq2, "))")
          message(paste0('      filter: ',gsub('argus_recoded_wtd$','',
                                               filter.freq,fixed=T)))
          
          keepvar <- c('respondentid',freqlvl,weightvar,demonames,
                       grep(paste0(antime,"diff"),names(argus_recoded_wtd),value=T))
          for (segs in 1:length(params$segmentlst)) {
            # segs = 1
            seg1 <- tolower(params$segmentlst[segs])
            keepvar <- c(keepvar,grep(paste0(seg1,"_carduser_"),
                                      names(argus_recoded_wtd),value=T))
            keepvar <- c(keepvar,grep(paste0(seg1,"_cardholder_"),
                                      names(argus_recoded_wtd),value=T))
          }
          
          datain <- argus_recoded_wtd[eval(parse(text=filter.freq)),keepvar,with=F]
          output.dt <- ttests(params = params
                              ,datain = datain
                              ,output.dt = output.dt
                              ,iexp = x
                              ,freqlvl = freqlvl
                              ,exposure = exposure
                              ,weightvar = weightvar
                              ,antime = antime
                              ,anframe = anframe
                              ,statexpdesc = statexpdesc
                              ,freq1 = freq1
                              ,freq2 = freq2
                              ,prfr = prfr
                              ,alternative = alternative
                              ,publisher = publishername
                              ,creative = creativename
                              ,tactic = tacticname
                              ,mediatype = mediatypename
                              ,market = marketname
                              ,pretime = pretime
          )
          rm(datain)
          foo <- gc()
          message(paste0('      }'))
          
        } # Close loop over frequencies
        
        message(paste0('\n    Writing results to ',params$datapath,'/',
                       'stattest_preper',iprtime,'_exp',x,'.RData'))
        save(output.dt, file=paste0(params$datapath,'/','stattest_preper',
                                    iprtime,'_exp',x,'.RData'))
        rm(output.dt)
        foo <- gc()
        
        endexp <- Sys.time()
        message(paste0('\n    Exposure took: ', format(endexp-startexp)))
        message(paste0('    }'))
        
      } #exposure loop
      message(paste0('  }'))
    } # loop over preperiod
    
    rm(argus_recoded_wtd)
    foo <- gc()
    
    # Build full output from individual exposure files written to disk
    message('\n  Building full output from individual exposure files written to disk.')
    data_list <- list()
    framecount <- 1
    for (iprtime in seq_along(params$pre_list)) {
      for (x in 1:params$exposuren) {
        message(paste0('  - Loading ',params$datapath,'/','stattest_preper',
                       iprtime,'_exp',x,'.RData'))
        data_list[[framecount]] <- loadRData_noalloc(paste0(params$datapath,'/',
                                    'stattest_preper',iprtime,'_exp',x,'.RData'))
        framecount <- framecount+1
        file.remove(paste0(params$datapath,'/','stattest_preper',iprtime,'_exp',
                           x,'.RData'))
      }
    }
    output.dt <- data.table::rbindlist(data_list)
    
    # Half the pvalue for the ttest, wilcoxon test is already one tailed pvalue
    if (alternative == "two.tailed") {
      output.dt[, Probt1 := pvalue/2]
    } else {
      output.dt[, Probt1 := pvalue]
    }
    
    if (params$NMCoutput) {
      # Prepare NMC output
      stattest.dt <- cleantest_NMC(copy(output.dt))
      
      # Write NMC output to disk
      message(paste0('\n  Writing ',params$outputpath,'/',tolower(params$proj),
                     "_stattest_wtd_NMC.csv"))
      write.csv(stattest.dt,paste0(params$outputpath,'/',tolower(params$proj),
                                   "_stattest_wtd_NMC.csv"),row.names=F)
      
      message(paste0('\n  Writing ',params$datapath,'/',tolower(params$proj),
                     '_stattest_wtd_NMC.RData'))
      save(stattest.dt, file=paste0(params$datapath,'/',tolower(params$proj),
                                    '_stattest_wtd_NMC.RData'))
      
      rm(stattest.dt)
      foo <- gc()
    }
    
    # Prepare output for Excel-macro format
    stattest.dt <- cleantest_Excel(copy(output.dt))
    rm(output.dt)
    foo <- gc()
    
    # Write output for Excel-macro to disk
    message(paste0('\n  Writing ',params$outputpath,'/',tolower(params$proj),
                   "_stattest_wtd.csv"))
    write.csv(stattest.dt,paste0(params$outputpath,'/',tolower(params$proj),
                                 "_stattest_wtd.csv"),row.names=F)
    
    message(paste0('\n  Writing ',params$datapath,'/',tolower(params$proj),
                   '_stattest_wtd.RData'))
    save(stattest.dt, file=paste0(params$datapath,'/',tolower(params$proj),
                                  '_stattest_wtd.RData'))
    
    rm(stattest.dt)
    foo <- gc()
    
    # Validation of output
    if (params$mod_41$val) {
      
      # The list of names of files to compare, in pairs (first is always 
      # the model file, and second is always the comparison file)
      # For each filename in filename_list, provide the name of the column(s) that
      # identify each unique row
      # Ex. key_column_list <- list('respondentid',
      #                             c('hhid','personid'))
      if (params$NMCoutput) {
        filename_list <- list(c(paste0(params$val_dir,'/Output/',tolower(params$proj),
                                       '_stattest_wtd.csv'),
                                paste0(params$datapath,"/",tolower(params$proj),
                                       "_stattest_wtd.RData"))
                              ,c(paste0(params$val_dir,'/Output/',tolower(params$proj),
                                        '_stattest_wtd_NMC.csv'),
                                 paste0(params$datapath,"/",tolower(params$proj),
                                        "_stattest_wtd_NMC.RData"))
        )
        key_column_list <- list(c('preperiod','exposure','demo','merchant',
                                  'stat','variable_name')
                                ,c('exposure','metric','type','freq','demo'))
      } else {
        filename_list <- list(c(paste0(params$val_dir,'/Output/',
                                       tolower(params$proj),'_stattest_wtd.csv'),
                                paste0(params$datapath,'/',
                                       tolower(params$proj),'_stattest_wtd.RData'))
                             )
        key_column_list <- list(c('preperiod','exposure','demo','merchant',
                                  'stat','variable_name'))
      }
      
      validate_41(params,filename_list,key_column_list)
      
    }
    
  }
  
}
################################################################################
############################## Run Main Function ###############################
################################################################################
if (getOption('run.main', default=TRUE)) {
  
  # UTILITY FUNCTIONS (these are normally loaded by 10SetParameters)
  
  # Function that checks if package is installed.
  # If installed, it loads it. If it isn't, it installs it.
  pkgTest <- function(x) {
    if (!(x %in% installed.packages()[, 'Package'])) {
      tryCatch({
        message(paste0('INSTALLING PACKAGE ',toupper(x)))
        if (x == 'xda') {
          install_github("ujjwalkarn/xda")
        } else {
          install.packages(x, quiet = TRUE)
        }
      }, error = function(e) {
        stop(paste0('  ERROR: ',e))
      })
    } 
    message(paste0('LOADING PACKAGE ',toupper(x)))
    library(x,character.only = TRUE, quietly = TRUE)
  }
  
  # Function to format list to write to file
  write_list <- function(prefix,list,indent,total_length) {
    llist <- length(list)
    cond <- 1
    count <- 1
    while (cond) {
      ltoprint <- paste(list[1:count],collapse=', ')
      line <- paste(prefix,ltoprint)
      lline <- nchar(line)
      if (lline < total_length) {
        if (count < llist) {
          count <- count+1
        } else {
          cond <- 0
        }
      } else {
        cond <- 0
        count <- count-1
        if (count < 1) {
          line <- prefix
        } else {
          ltoprint <- paste(list[1:count],collapse=', ')
          line <- paste(prefix,ltoprint)
        }
      }
    }
    message(line)
    
    prefix <- paste(rep(" ",indent),collapse="")
    
    while (count < llist) {
      cond <- 1
      count <- count+1
      count2 <- count
      while (cond) {
        ltoprint <- paste(list[count2:count],collapse=', ')
        line <- paste0(prefix,ltoprint)
        lline <- nchar(line)
        if (lline < total_length) {
          if (count < llist) {
            count <- count+1
          } else {
            cond <- 0
          }
        } else {
          cond <- 0
          count <- count-1
          if (count < count2) {
            count <- count+1
          } else {
            ltoprint <- paste(list[count2:count],collapse=', ')
            line <- paste0(prefix,ltoprint)
          }
        }
      }
      message(line)
    }
  }
  
  # Get index of columns in a dataset
  get_indexes <- function(columns,dataset) {
    columns <- tolower(columns)
    indexes <- c()
    for (colname in columns) {
      indexes <- c(indexes,match(colname,tolower(names(dataset))))
    }
    return(indexes)
  }
  
  compareNA <- function(v1,v2) {
    same <- (v1 == v2) | (is.na(v1) & is.na(v2))
    same[is.na(same)] <- FALSE
    return(!same)
  }
  
  # Function to compare two data.table objects and write differences to file
  validate_dt_file <- function(Modelfile,Comparisonfile,key_column,outname,
                               dump_diff_file) {
    
    # First test: Check that both files have the same number of columns and rows
    
    ncolSAS <- base::ncol(Modelfile)
    nrowSAS <- base::nrow(Modelfile)
    ncolCSV <- base::ncol(Comparisonfile)
    nrowCSV <- base::nrow(Comparisonfile)
    
    if ((ncolSAS == ncolCSV) && (nrowSAS == nrowCSV)) { 
      
      # Second test: Check that columns in both files have the same names
      #              (case can be different (uppercase vs. lowercase) and order
      #               of the columns can be different, but names have to be the same)
      
      SAScolnames <- base::sort(base::tolower(base::colnames(Modelfile)))
      CSVcolnames <- base::sort(base::tolower(base::colnames(Comparisonfile)))
      ndiff <- 0
      for (icol in 1:base::length(SAScolnames)) {
        if (SAScolnames[icol] != CSVcolnames[icol]) { ndiff <- ndiff+1 }
      }
      
      if (ndiff == 0) {
        
        # Third test: Compare files column-by-column
        
        # Rearrange Rfile columns to be in the same order as Modelfile
        base::names(Modelfile) <- base::tolower(base::names(Modelfile))
        base::names(Comparisonfile) <- base::tolower(base::names(Comparisonfile))
        if (ncolSAS > 1) {
          Comparisonfile <- Comparisonfile[,names(Modelfile),with=F]
        }
        
        # Sort datasets according to key_column to have rows in the same order
        indexes <- get_indexes(key_column,Modelfile)
        key_names <- base::names(Modelfile)[indexes]
        if (nrowSAS > 1) {
          Modelfile <- setorderv(Modelfile,key_names)
          Comparisonfile <- setorderv(Comparisonfile,key_names)
        }
        
        # Use "compare" function to validate each column in the file against its 
        # SAS counterpart
        count <- 0
        for (i in 1:ncolSAS) {
          #i=6
          comparison <- compare::compare(Modelfile[[i]], Comparisonfile[[i]]
                                         ,equal = TRUE
                                         ,coerce = TRUE
                                         #,shorten = TRUE
                                         #,ignoreOrder = TRUE
                                         #,ignoreNameCase = TRUE
                                         #,ignoreNames = TRUE
                                         ,ignoreAttrs = TRUE
                                         ,round = TRUE
                                         #,ignoreCase = TRUE
                                         #,trim = TRUE
                                         #,dropLevels = TRUE
                                         #,ignoreLevelOrder = TRUE
                                         #,ignoreDimOrder = TRUE
                                         #,ignoreColOrder = TRUE
                                         #,ignoreComponentOrder = TRUE
                                         #,colsOnly = TRUE
                                         #,allowAll = TRUE
          )
          
          # If discrepancies are found, write discrepancies to file for evaluation
          # by the user
          if (!comparison$result) {
            count <- count+1
            base::message(paste0('  - Found discrepancies in column: ',
                                 base::names(Modelfile)[i]))
            if (dump_diff_file) {
              SAS_np <- Modelfile[compareNA(comparison$tM[], comparison$tC[]),c(indexes,i),with=F]
              
              CSV_np <- Comparisonfile[compareNA(comparison$tM[], comparison$tC[]),c(indexes,i),with=F]
              
              base::names(SAS_np) <- base::paste0('Model_',base::names(SAS_np))
              base::names(CSV_np) <- base::paste0('Comparison_',base::names(CSV_np))
              for (j in 1:base::length(key_names)) {
                base::names(CSV_np)[base::names(CSV_np) == base::paste0('Comparison_',key_names[j])] <- key_names[j]
                base::names(SAS_np)[base::names(SAS_np) == base::paste0('Model_',key_names[j])] <- key_names[j]
              }
              
              diff <- base::merge(SAS_np, CSV_np, by=key_names, all=TRUE)
              base::message(paste0('    ',nrow(diff),' discrepancies found.'))
              model_name <- paste0('Model_',names(Modelfile)[i])
              comparison_name <- paste0('Comparison_',names(Modelfile)[i])
              if (class(diff[[model_name]]) == 'numeric') {
                diff$`%Diff` <- round((diff[,comparison_name,with=F]-diff[,model_name,with=F])/
                                        diff[,model_name,with=F]*100,0)
              }
              
              if (count == 1) {
                xlsx::write.xlsx(diff,paste0(outname,'.xlsx'),row.names=FALSE
                                 ,sheetName = base::names(Modelfile)[i])
              } else {
                xlsx::write.xlsx(diff,paste0(outname,'.xlsx'),row.names=FALSE
                                 ,sheetName = base::names(Modelfile)[i],append = TRUE)
              }
              
              jgc()
            }
          }
        }
        
        if (count == 0) {
          base::message('  - No discrepancies were found.')
        } else {
          if (dump_diff_file) {
            base::message(paste0('  - Report saved in ',outname,'.xlsx'))
            # Sys.setenv(RSTUDIO_PANDOC="C:/Program Files/RStudio/bin/pandoc")
            # render(paste0(params$code_loc,"/gen_val_report.Rmd"),#'all',
            #        output_file = paste0(outname,'.html'),
            #        params = list(path = params$path, outname = outname),
            #        quiet = T)
          }
        }
        
        
      } else {
        
        base::message('  - Discrepancies were found.')
        base::message('    Column names in model and comparison datasets do not match.')
        write_list('    Column names in model dataset are:', SAScolnames, 
                   6,80)
        write_list('    Column names in comparison dataset are:', CSVcolnames, 
                   6,80)
        
      }
      
    } else {
      
      base::message('  - Discrepancies were found.')
      base::message(base::paste0('    The model dataset has ',base::toString(nrowSAS)
                                 ,' rows and ',base::toString(ncolSAS),' columns.'))
      base::message(base::paste0('    while the comparison dataset has ',base::toString(nrowCSV)
                                 ,' rows and ',base::toString(ncolCSV),' columns.'))
    }
    
  }
  
  # Function to collect Java garbage when using xlsx package
  jgc <- function() {
    base::gc()
    .jcall("java/lang/System", method = "gc")
  }
  
  # Function to load and rename RData file, and allocate memory to it
  loadRData <- function(fileName,colalloc){
    #loads an RData file, and returns it
    load(fileName)
    alloc.col(get(ls()[ls() != "fileName"]),colalloc)
  }
  
  # Function to load and rename RData file
  loadRData_noalloc <- function(fileName) {
    #loads an RData file, and returns it
    load(fileName)
    get(ls()[ls() != "fileName"])
  }
  
  # IMPORT PACKAGES
  # (these are normally loaded by the main script - 10SetParameters)
  pkgTest('Hmisc')
  pkgTest('data.table')
  pkgTest('jsonlite')
  pkgTest('haven')
  options(java.parameters = "-Xmx16000m")
  pkgTest('rJava')
  pkgTest('xlsx')
  pkgTest('compare')
  pkgTest('rmarkdown')
  pkgTest('knitr')
  pkgTest('kableExtra')
  
  path <- 'E:/Citi_Amazon'
  params <- fromJSON(file.path(path,'params.json'), simplifyDataFrame=TRUE)
  if (params$use_sas_input) {
    if (params$val_format == 'sas7bdat') {
      message(paste0('  Loading ',params$val_dir,'/SAS_Datasets/',
                     tolower(params$bigseg),'_',tolower(params$datatype),'_wtd.sas7bdat'))
      argus_recoded_wtd <- as.data.table(haven::read_sas(paste0(params$val_dir,
                           '/SAS_Datasets/',tolower(params$bigseg),'_',
                           tolower(params$datatype),'_wtd.sas7bdat')))
    } else if (params$val_format == 'RData') {
      message(paste0('  Loading ',params$val_dir,'/SAS_Datasets/',tolower(params$bigseg),
                     '_',tolower(params$datatype),'_wtd.RData'))
      argus_recoded_wtd <- loadRData_noalloc(paste0(params$val_dir,'/SAS_Datasets/',
                                                    tolower(params$bigseg),'_',
                                                    tolower(params$datatype),'_wtd.RData'))
    }
    names(argus_recoded_wtd) <- tolower(names(argus_recoded_wtd))
    
    if (params$path == 'E:/Citi_Amazon') {
      argus_recoded_wtd[, weight_citi := weight_amazon]
      for (seg in tolower(params$segmentlst)) {
        for (stat in c('cardcount','cardholder','balyes','cyclebal',
                       'openflag','closeflag')) {
          for (period in c('pre','test','testdiff')) {
            argus_recoded_wtd[, paste(seg,stat,period,sep='_') := 
                                argus_recoded_wtd[[paste('citi',stat,period,sep='_')]]]
          }
        }
        stat <- 'openflag'
        for (period in params$period.def$test) {
          argus_recoded_wtd[, paste(seg,stat,period,sep='_') := 
                              argus_recoded_wtd[[paste('citi',stat,period,sep='_')]]]
        }
        stat <- 'cardholder'
        argus_recoded_wtd[, paste(seg,stat,sep='_') := 
                            argus_recoded_wtd[[paste('citi',stat,sep='_')]]]
      }
    } else if (params$path == 'E:/CapOne') {
      argus_recoded_wtd[, total_spend_testdiff := total_spd_testdiff]
      argus_recoded_wtd[, total_spend_testydiff := total_spd_testydiff]
    }
    
  } else {
    message(paste0('  Loading ',params$datapath,'/argus_20b.RData'))
    argus_recoded_wtd <- loadRData(paste0(params$datapath,'/argus_20b.RData'),
                                   params$colalloc)
  }
  main_41(params,argus_recoded_wtd)
  
}